/*******************************************************************************
 * Copyright (c) 2015-2018 Skymind, Inc.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Apache License, Version 2.0 which is available at
 * https://www.apache.org/licenses/LICENSE-2.0.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 ******************************************************************************/

package org.deeplearning4j.rl4j.learning;

import org.deeplearning4j.rl4j.mdp.MDP;

/**
 * The common API between Learning and AsyncThread.
 *
 * Express the ability to count the number of step of the current training.
 * Factorisation of a feature between threads in async and learning process
 * for the web monitoring
 *
 * @author Alexandre Boulanger
 * @author rubenfiszel (ruben.fiszel@epfl.ch) on 8/5/16.
 */
public interface IEpochTrainer extends EpochStepCounter {
    int getStepCounter();
    int getEpochCounter();
    IHistoryProcessor getHistoryProcessor();
    MDP getMdp();
}
